<template>
<div>
    <div class="row">
    <div class="col-lg-12">
      <div class="ibox float-e-margins">
        <div class="ibox-title">
            <h5>List Of Company Sub Account</h5>
            <div class="ibox-tools">
                <a class="btn btn-primary btn-xs" @click="modal_show()">
                    Add Sub Account
                </a>
                <a @click="load_company_sub_account()">
                    <i class="fa fa-refresh"></i>
                </a>
          </div>
        </div>
        <!-- /.ibox-titel -->
        
        <div class="ibox-content">
            <!-- Search and filter form -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="pull-left form-inline">
                        <label>Show 
                            <input type="number" v-model="show_row" class="form-control input-sm" 
                                    style="width:60px;" min="1" max="1000">
                        </label>


                        <label>&nbsp;&nbsp;Limit
                            <input type="number" v-model="limit" class="form-control input-sm" 
                                    style="width:70px;" min="1" max="1000">
                        </label>
                    </div>

                    <div class="pull-right form-inline">
                        <label>Search:
                            <input v-model="search_key" class="form-control input-sm">
                        </label>&nbsp;
                    </div>
                </div>
            </div>
            <!-- /.row -->
          
            <div class="row" v-if="company_sub_accounts.total">
                <div class="col-lg-12">
                    <div>
                        <div>
                            <p class="pull-left" style="margin-top: 7px;">
                                Showing  {{ company_sub_accounts.from }} to  {{ company_sub_accounts.to }}  of  {{ company_sub_accounts.total }} entries.
                            </p>
                        </div>
                        <div class="table_pagination">
                            <div class="btn-group pull-right pagination pagination-sm no-margin" style="margin:-0px;">
                        
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !company_sub_accounts.prev_page_url }" 
                                    @click=" gen_uri( company_sub_accounts.prev_page_url )"
                                >
                                    <span>Prev</span>
                                </a>  
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !company_sub_accounts.first_page_url }" 
                                    @click=" gen_uri( company_sub_accounts.first_page_url )">
                                    <span>First</span>
                                </a>
                                <a class="btn btn-white btn-sm disabled"><span>...</span></a>
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !company_sub_accounts.last_page_url }" 
                                    @click=" gen_uri(company_sub_accounts.last_page_url)">
                                <span>Last</span>
                                </a>
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !company_sub_accounts.next_page_url }" 
                                    @click=" gen_uri( company_sub_accounts.next_page_url )"
                                >
                                <span>Next</span>
                                </a>
                            </div>
                        </div>        
                    </div>
                </div>
            </div>
            <!-- /.row -->

            <!-- Table -->
            <div class="project-list table-responsive">
                <table class="table table-stripped">
                    <thead>
                        <tr>
                            <th class="text-center">#</th>
                            <th>Company Acc.</th>
                            <th>Code</th>
                            <th>Description</th>
                            <th>&nbsp;</th>
                        </tr>
                    </thead>
                    <tbody v-if="loading">
                        <tr>
                            <td colspan="5">
                                <spinner></spinner>
                            </td>
                        </tr>
                    </tbody>
                    <tbody  v-else-if="company_sub_accounts.data.length">
                        <account-table v-for="(company_sub_account, row) in company_sub_accounts.data" 
                                    :key="company_sub_account.id" 
                                    :companySubAccount="company_sub_account" 
                                    :row="row"
                                    v-on:edit="modal_show"
                                    v-on:delete="company_sub_account_delete"
                        >
                        </account-table>
                    </tbody>
                    <tbody v-else>  
                        <tr>
                            <td colspan="7" class="text-center">
                                No Result!
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <!-- /.table-responsive -->
        </div>
        <!-- /.ibox-content -->
      </div>
      <!-- /.ibox float-e-margins -->
    </div>
    <!-- /.col-lg-12 -->
  </div>
  <!-- /.row -->

  <account-modal v-on:save="company_sub_account_save" v-bind:modal="modal">
  </account-modal>
</div>
</template>

<script>
import axios from 'axios'
import Table from './Table.vue'
import Modal from './Modal.vue'
import Spinner from '../../../other/Spinner.vue'
import appService from '../../../../app.service.js'

export default {
    components: {
        'account-modal': Modal,
        'account-table': Table,
        'spinner': Spinner
    },
    data () {
        return {
            loading: false,
            search_key: '',
            show_row: 10,
            limit: 100,
            uri: '',
            company_sub_accounts: [],
            modal: { 
                pause_save: false,
                errors: '',
                company_accounts: '',
                data: {
                    code: '',
                    description: '',
                    id: ''
                }
            },
        }
    },
    methods: {
        load_company_sub_account () {
            this.loading = true
            let uri = this.uri
            uri = uri.replace("chart-of-account", "company-sub-account")
            axios.get(uri).then(response => {
                this.company_sub_accounts = response.data.company_sub_accounts
                this.loading = false
            }).catch(response => {
                reject(response.status)
                this.loading = false
            })
        },
        get_company_account_list () {
            axios.get('company-account?for_list=true').then(response => {
                this.modal.company_accounts = response.data.company_accounts
            })
        },
        gen_uri (qry_page = '') {
            let query = {
                base: 'chart-of-account',
                page: qry_page.substr(1),
                show_row: this.show_row,
                limit: this.limit,
                search_key: this.search_key,
            }

            let uri = appService.crud.generate_url( query )
            uri = uri.replace("per_page", "sub_per_page")
            uri = uri.replace("limit", "sub_limit")
            uri = uri.replace("search_key", "sub_search_key")

            this.uri = uri
            this.$router.push( this.uri )
        },
        modal_show( row_data ) {
            this.get_company_account_list ()
            this.modal.errors = ''

            if(row_data) {
                this.modal.data = {
                    code: row_data.code,
                    description: row_data.description,
                    company_account: row_data.company_account,
                    id: row_data.id,
                }
            }else{
                this.modal.data = {
                    code: '',
                    description: '',
                    company_account: '',
                    id: '',
                }
            }

            $('#company_sub_account_modal').modal('show');
        },
        company_sub_account_save( data ) {
            this.modal.pause_save = true
            if(!data.id) {
                this.company_sub_account_store( data )
            }else{
                this.company_sub_account_update( data )
            }
        },
        company_sub_account_store( data ) {
            appService.crud.store( '/company-sub-account', data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#company_sub_account_modal').modal('hide')
                    toastr.success( response.message, 'Saved!' )
                    this.load_company_sub_account()
                }
                this.modal.pause_save = false
            })
        },
        company_sub_account_update( data ){
            appService.crud.update( `/company-sub-account/${data.id}`, data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#company_sub_account_modal').modal('hide')
                    toastr.success( response.message, 'Updated!' )
                    this.load_company_sub_account()
                }
            })
            this.modal.pause_save = false
        },
        company_sub_account_delete( id ){
            appService.crud.delete( `/company-sub-account/${id}` ).then(response => {
                if(response.errors) {
                    toastr.error( response.message, 'Error!' )
                }else{
                    toastr.error( response.message, 'Deleted!' )
                    this.load_company_sub_account()
                }
            })
        },
    },  
    watch: {
        '$route' (to, from) {
            this.load_company_sub_account()
        },
        show_row: function () {
            this.loading = true
            this.gen_uri()
        },
        limit: function () {
            this.loading = true
            this.gen_uri()
        },
        search_key: function () {
            this.loading = true
            setTimeout(() => {
                this.gen_uri()
            }, 1500)
        }
    },
    created () {
        this.gen_uri()
        this.load_company_sub_account()
    }
}
</script>
